Navigation Menu

Skip to content

Instantly share code, notes, and snippets.

Show Gist options
  • Star 0 You must be signed in to star a gist
  • Fork 0 You must be signed in to fork a gist
  • Save hackjutsu/7410873bc72f89fe0aa1a59af620a076 to your computer and use it in GitHub Desktop.
Save hackjutsu/7410873bc72f89fe0aa1a59af620a076 to your computer and use it in GitHub Desktop.
Two Pointer - Container with Most Water

Given n non-negative integers a1, a2, ..., an , where each represents a point at coordinate (i, ai). n vertical lines are drawn such that the two endpoints of line i is at (i, ai) and (i, 0). Find two lines, which together with x-axis forms a container, such that the container contains the most water. From https://leetcode.com/problems/container-with-most-water/

Algorithm

The intuition behind this approach is that the area formed between the lines will always be limited by the height of the shorter line. Further, the farther the lines, the more will be the area obtained.

We take two pointers, one at the beginning and one at the end of the array constituting the length of the lines. Futher, we maintain a variable \text{maxarea}maxarea to store the maximum area obtained till now. At every step, we find out the area formed between them, update \text{maxarea}maxarea and move the pointer pointing to the shorter line towards the other end by one step.

How this approach works?

Initially we consider the area constituting the exterior most lines. Now, to maximize the area, we need to consider the area between the lines of larger lengths. If we try to move the pointer at the longer line inwards, we won't gain any increase in area, since it is limited by the shorter line. But moving the shorter line's pointer could turn out to be beneficial, as per the same argument, despite the reduction in the width. This is done since a relatively longer line obtained by moving the shorter line's pointer might overcome the reduction in area caused by the width reduction.

class Solution:
    def maxArea(self, height: List[int]) -> int:
        theMax = 0
        l = 0
        r = len(height)-1
        
        while(l < r):
            area = min(height[l], height[r]) * (r - l)
            if area > theMax:
                theMax = area
            if height[l] < height[r]:
                l += 1
            else:
                r -= 1

        return theMax

The inefficent solution is below, takes n² time.

class Solution:
    def maxArea(self, height: List[int]) -> int:
        theMax = 0
        slow = 0
        
        while(slow <= len(height)):
            fast = slow + 1
            while(fast <= len(height)-1):
                x = fast - slow
                area = min(height[slow], height[fast]) * x
                if area > theMax:
                    theMax = area
                fast += 1
            slow += 1
            
	return theMax
Sign up for free to join this conversation on GitHub. Already have an account? Sign in to comment